.386
.model flat,stdcall
option casemap:none

include		\GeneSys\include\windows.inc
include		\GeneSys\include\kernel32.inc
include		\GeneSys\include\user32.inc
include		\GeneSys\include\GeneSys.inc

includelib	\GeneSys\lib\kernel32.lib
includelib	\GeneSys\lib\user32.lib
includelib	\GeneSys\lib\GeneSys.lib

PUBLIC		variable,teststring

.data
variable	dd 1000
teststring	db 'This is a test',0
template	db 'Test string = %s',13,10
			db 'Variable    = %d',0

.data?
buffer		db 100 dup(?)

.code

start:

LibMain PROC instance:DWORD,reason:DWORD,unused:DWORD 

    mov		eax,TRUE
    ret

LibMain ENDP

; When the -export directive is specified, the STDCALL calling convention preserves
; the name mangling in the final DLL
; The C convention is used to avoid the name mangling in the DLL

testfunc PROC C str1:DWORD,var:DWORD

	invoke	wsprintf,ADDR buffer,ADDR template,str1,var
	invoke	ConsoleOut,ADDR buffer
	ret 2*4			; manual stack balancing to simulate STDCALL

testfunc ENDP

END LibMain
